# Contributing

We welcome contributions and assistance! If you want to know where to start, check out our [Github Projects sorted by name](https://github.com/d0p3t/fivem-js/projects?query=is%3Aopen+sort%3Aname-asc).

If you want to add a new feature, note that we strive to support the FiveM OneSync system, so keep that in mind when submitting feature requests.

## Development

To get setup for development, refer to [DEVELOPMENT.md](./DEVELOPMENT.md)

## Issues

We use GitHub issues to track public bugs and requests. Please ensure your bug description is clear and has sufficient instructions to be able to reproduce the issue. THe best way is to provide an example resource in JS that uses any of the fivem-js features directly.

## Pull Requests

All active development of this project happens on GitHub. We actively welcome your [pull requests](https://help.github.com/articles/creating-a-pull-request).

We require that all pull requests are made in the development branch. Please beware of that when opening a new PR.

## Commit Message Conventions

We don't have any strict commit message rules, but we encourage you to keep your commit messages short and descriptive.

```
docs: Scaleform + LoadingPrompt
```
```
Added bone collections and Camera PointAt functions
```

Both these commit messages are descriptive, short and to the point.


## License

By contributing to fivem-js, you agree that your contributions will be licensed under the [LICENSE](./LICENSE) file in the project root directory.